#include "MsHtmdid.inc" // DISPID_AMBIENT_DLCONTROL
#include "dispatch.inc"

#ifndef __CAmbient__
#define __CAmbient__

class CAmbient : CDispatch
{
	// IDispatch methods
	declare virtual Invoke(DISPID dispIdMember, REFIID *riid, LCID lcid, USHORT wFlags, DISPPARAMS *pDispParams, VARIANT *pVarResult, EXCEPINFO *pExcepInfo, UINT *puArgErr),HRESULT;

	declare  CAmbient();
	declare _CAmbient();

	// call these two methods before navigation: SetAmbient();Navigate();SetAmbient();Navigate(); ...
	// you can also call it from events::BeforeNavigate (SetAmbient methods is working always)
	declare SetAmbient(IWebBrowser2 *browser, DWORD dwAmbient);
	// for user-agent list, see in http://user-agents.org/
	declare SetUserAgent(IWebBrowser2 *browser, LPWSTR UserAgent);

	// called from SetAmbient and SetUserAgent
	declare NotifyChange(IWebBrowser2 *browser, DISPID dispIdMember);

	DWORD m_ambient;
	BSTR  m_UserAgent;
}

#endif
